Index: src/Fl_Screen_Driver.cxx
===================================================================
--- src/Fl_Screen_Driver.cxx	(Revision 12517)
+++ src/Fl_Screen_Driver.cxx	(Arbeitskopie)
@@ -28,6 +28,7 @@
 #include <FL/Fl_Image_Surface.H>
 #include <FL/Fl_Box.H>
 #include <FL/Fl_Tooltip.H>
+#include <FL/Fl_System_Driver.H> // for Fl::system_driver()
 
 char Fl_Screen_Driver::bg_set = 0;
 char Fl_Screen_Driver::bg2_set = 0;
@@ -449,6 +450,9 @@
       f = scaling_values[i];
     }
     if (f == old_f) return 1;
+    char var[50];
+    snprintf(var, sizeof(var), "FLTK_SCALING_FACTOR=%f", f*initial_scale);
+    Fl::system_driver()->putenv(var); // export the current scaling factor
     screen_dr->rescale_all_windows_from_screen(screen, f*initial_scale);
     Fl_Screen_Driver::transient_scale_display(f, screen);
     screen_dr->init_workarea();
